; Program Jednoduchy citac
; Displej se spolecnou katodou pripojen pres odpory primo na PIC bey dekoderu
; dekodovani BCD->7sgement se provadi programove

		INCLUDE P16F627A.INC
; ***   Definice konstant  ***
							;*******************************************************************;
DOLAD_JEMNE equ D'30'		; *** Korekcni konstanta krystalu, zmena 1 odpovida 2 us,  ***  	;
							; tj. 1/16000 pri 2 MHz krystalu, 									;
							; pri f vstup=32 MHz zmena EE o 1 odp. 2kHz mereneho kmitoctu		;
							; Pro krystal presne 2 MHz ma byt 30								;
							;*******************************************************************;

							;***********************************************************************;
HRUBE1MS equ D'122'			; Hrube nastaveni casovaci rutiny CEK1 trvajici 1 ms - pocet pruchodu 	;
							; cekaci smyckou ktera trva 4 kroky (2 obyc. instrukce + 1 skok). 		;
							; Cyklus musi byt cca o 12 kroku kratsi nez 1 ms. Tuto konstantu zmente	;
							; jen pri frekvenci krystalu vyrazne odlisne od 2 MHz					;
							;***********************************************************************;

; *** Deklarace promennych	***
KK	equ 0x20
LL	equ 0x21
MM	equ 0x22
EE	equ 0X23
P_BUF EQU 0x24
P_BCD EQU 0x25
L_byte  equ 0x26	; Binarni data urcena k prevodu do BCD a zobrazeni 
H_byte  equ 0x27
CFGSWI equ 0x28	; Sem se cte poloha cfg propojek a prepinacu
				; bit 0 Prepinac odcitani mf kmitoctu, kdyz je 1, odcita se.
				; bit 1 rezerva
				; bity 2-4 Volba mf kmitoctu
				; bit 5 - rezerva
				; 
MF_L equ 0x29	; Mezifrekvencni kmitocet v kHz
MF_H equ 0x2A
PRIZNAKY equ 0x2B ; Ruzne bitove priznaky:
				  ;
				  ; bit 7 Podteceni pri scitani - docasna promenna, pouzivana v rutine D_ADD
DECIMAL_DOT equ 0x2C
DISP_BCD_INPUT equ 0x2D ; 2B Cislo urcene k zobrazeni v BCD kodu
DISP_BUFF equ 0x30		; 6B pole cislic v kodu displeje, postupne se posilaji do displeje
DISP_STAV equ 0x36		; cislo momentale zobrazovane cislice
ACCaLO equ 0x37			; Akumulator pro 16b aritmeticke operace
ACCaHI equ 0x38			;
CFGSWI_OLD equ 0x39		; Minuly stav propojek a spinacu
JJ equ 0x3A				; pomocna promenna cyklu
KLID_PORTB equ 0x3B		; Klidovy stav portu B
DIAG_PORTB equ 0x3C

start1  ORG 0x001
		GOTO START2		; Skok na zacatek hlavniho programu
		ORG 0x005
; *** Podprogramy vyuzivajici prikazy ADDWF PCL ***
; Jsou umisteny v prvni pametove strance
; aby zabranilo preteceni  dolnich 8 bitu PCL pri scitani a ztrate programu

MERFREQ0	; ** Rutina na mereni frekvence **
		; Vstupni promenne:
		; v KK je pocet milisekund
		; v EE hruba korekcni konstanta od 0 do 255
		; Vystup je v L_byte a H_byte
		CLRF TMR1L	; nulovani citace
		CLRF TMR1H
		MOVF EE,W		;W=EE
		RRF EE,F		; EE=EE/4
		BCF EE,7
		RRF EE,F
		BCF EE,7
		INCF EE,F		; ++EE, aby pri EE=0 nepodtekla smycka, EE musi byt alespon 1
		ANDLW B'00000011' ; Do W se daly dolni 2 bity z EE
		SUBLW D'3' ; Obraceni MM aby cas rostl s vetsm MM
	; * Spusteni citace
		BSF T1CON, 0
		ADDWF PCL,F ;jemna korekce - preskoceni 0-3 zbytecnych instrukci
		CLRWDT
		CLRWDT
		CLRWDT
KORKC	CLRWDT		; hruba korekce - zpozdovaci smycka, jeden pruchod trva 4 kroky
		DECFSZ EE, 1 ; Kratky korekcni cyklus
		GOTO KORKC
MERMSCYKL	; Hlavni casomerny cyklus
		CLRWDT
		CALL CEK1
		DECFSZ KK,F
		GOTO MERMSCYKL
	; * Zastaveni citace
		BCF T1CON, 0
		CLRWDT
		MOVF TMR1L,0
		MOVWF L_byte
		MOVF TMR1H,0
		MOVWF H_byte
KONECMF	RETURN



DISPTAB	; Prevod BCD-7segment displej. 
		; Vstup: V dolnich 4 bitech W je BCD kod cisla
		; Vystup: ve W je kod displeje
		ANDLW 0x0F	; Odseknuti hornich bitu, aby program nemohl zabloudit pri
					; vetsim vstupnim cisle
		ADDWF PCL, F ; Cteni z tabulky konstant skokem+Retlw
		RETLW B'00111111' ; 0
		RETLW B'00000110' ; 1
		RETLW B'01011011' ; 2
		RETLW B'01001111' ; 3
		RETLW B'01100110' ; 4
		RETLW B'01101101' ; 5
		RETLW B'01111101' ; 6
		RETLW B'00000111' ; 7
		RETLW B'01111111' ; 8
		RETLW B'01101111' ; 9
		RETLW B'01011000' ; 0xA c - konstanta
		RETLW B'01011100' ; 0xB o - overflow, preteceni vysledku
		RETLW B'00011100' ; 0xC u - underflow, podteceni vysledku
		RETLW B'01011110' ; 0xD d 
		RETLW B'01111001' ; 0xE E - error
		RETLW B'00000000' ; 0xF zhasnuty displej

; Tabulky mezifrekvencnich kmitoctu

; * Rutina cteni dolniho byte *
; Vstup: ve W je index (stav konfig. spinacu)
; Vystup: ve W
;	 Dolni byte tabulky mf kmitoctu
MFTAB_L	ANDLW 0x07	; Odseknuti dolnich 3 bitu y W
		ADDWF PCL, F 
		RETLW D'128' ; 128 kHz
		RETLW D'197' ; 453 kHz
		RETLW D'199' ; 455 kHz
		RETLW D'204' ; 460 kHz
		RETLW D'209' ; 465 kHz
		RETLW D'212' ; 468 kHz
		RETLW D'214' ; 470 kHz
		RETLW D'204' ; 10,7MHz

; * Rutina cteni horniho byte *
; Vstup: ve W je index (stav konfig. spinacu)
; Vystup: ve W
; Horni byte tabulky
MFTAB_H ANDLW 0x07
		ADDWF PCL,F
		RETLW D'0' ; 128 kHz
		RETLW D'1' ; 453 kHz
		RETLW D'1' ; 455 kHz
		RETLW D'1' ; 460 kHz
		RETLW D'1' ; 465 kHz
		RETLW D'1' ; 468 kHz
		RETLW D'1' ; 470 kHz		
		RETLW D'41'; 10,7 MHz
; Konec tabulek

START2	
; *** Zacatek hlavniho programu ***
;  *  Nastaveni konfiguracnich registru  *
;     Nastaveni portu
		BCF STATUS, 6	; Volba datove stranky 1
		BSF STATUS, 5
		MOVLW B'11110000'	;Dolnich 4 bitu portu A bude vystupnich (segmety A az D displeje), 
		MOVWF TRISA			; horni 3 b vstupni, A4 cteni stavu baterie 
		MOVLW B'11010000'	; Dolni 4 bity portu B budou vystupni (segmenty E, F, G a tecka displeje),
		MOVWF TRISB			; B4 cteni spinacu, B5 vystup aktivace/uspani predzesilovace
							; B6 vstup citaneho signalu, B7 nepouzit. 
		MOVLW B'11011111'	; OPTION: pull-up vypnut, fosc/4 do RTCC, preddelicka 1:128 k WDC
		MOVWF OPTION_REG
		BCF STATUS, 5		; Navrat na datovou stranku 0
		MOVLW B'00110110'	; Nastaveni TMR1 na vnejsi zdroj bez synchronisace, preddelicka 1:8
		MOVWF T1CON 		; Zatim je casovac zastaven, spusti se potom
		MOVLW B'11000111'	; Komparatory vypnuty
		MOVWF CMCON
; *** Konec pocatecniho nastaveni, zacatek tela programu ***
		CLRF PRIZNAKY
		CLRF DECIMAL_DOT
		MOVLW B'00100000'	; Pocatecni nastaveni klidoveho stavu portu B - displ.
		MOVWF KLID_PORTB	; zhasnut, predzesilovac zapnut
		MOVWF PORTB
		MOVLW D'5'			; Pocet pruchodu, po ktere je predzesilovac zapnut pro serizovani
		MOVWF DIAG_PORTB

; precte SE stav konfig. spinacu 
		CALL CTISWITCH1
		CALL ZOBRAZMF
		CALL TESTBAT	; Test stavu baterie		
STARTCITANI ; Mereni 32 ms s vnejsi predelickou 4x a vnitrni 8x, 
					;rozliseni 1 kHz rozsah 1k -65MHz
		CLRWDT
		BSF KLID_PORTB,5	; Zapnuti predzesilovace
		MOVF KLID_PORTB,W
		MOVWF PORTB
		MOVLW D'3'			; Cekani 30 ms, aby se ustalil predzesilovac
		MOVWF LL
		CALL CEK10X	

		MOVLW DOLAD_JEMNE		; EE = Korekcni konstanta krystalu
		MOVWF EE
		MOVLW D'32' ; Hruby udaj kolik milisekund trva merny cyklus
		MOVWF KK
		CLRF PCLATH ; PCLATH=0, protoze podprogram pouziva ADDWF PCL ve strance 0
		CALL MERFREQ0 ; 
; Podminene vypnuti predzesilovace						
		MOVF DIAG_PORTB,F		; Pokud DIAG_PORTB>0 jdi na --DIAG_PORTB
		BTFSC STATUS, Z
		GOTO VYPPRE			; jinak jdi na vypnuti predzesilovace
		DECF DIAG_PORTB,F	; -- DIAG_PORTB
		GOTO NEVYP
VYPPRE	BCF KLID_PORTB,5	; Vypnuti predzesilovace
		MOVF KLID_PORTB,W
		MOVWF PORTB
NEVYP
		MOVLW d'3'			; Nastaveni desetinne tecky
		MOVWF DECIMAL_DOT
		BTFSS CFGSWI,0		; Ma se odecitat MF ?
		GOTO ZOBRF	
		MOVF MF_L,W			; Ma se odecist - Vlozeni mf kmitoctu do ACCa
		MOVWF ACCaLO		
		MOVF MF_H,W
		MOVWF ACCaHI
ODECTIMF	CALL D_SUB 		; Odecteni mf kmitoctu
		BTFSC STATUS,C		;Nedoslo pri odcitani mezifrekvence k podteceni? 
		GOTO ZOBRF			; Nedoslo, jdi na zobrazeni vysledku
		MOVLW 0xCC  		; Doslo k podteceni, zobrazi se 3x "u"
		MOVWF DISP_BCD_INPUT
		MOVWF DISP_BCD_INPUT+1
		MOVWF DISP_BCD_INPUT+2
		CALL DISP_BCD_TO_BUF ; prevod do kodu displeje
		CALL ZOBR0			; Zobrazeni u u u
		GOTO SVCF	
ZOBRF	CALL ZOBRAZ1OKO		; Zobrazei ymereneho vysledku
SVCF	CALL TESTBAT		; Test stavu baterie
		MOVF CFGSWI,W		; Ulozeni stare konf. switchu
		MOVWF CFGSWI_OLD
		CALL CTISWITCH1		; Precteni switchu
		MOVF CFGSWI,W
		SUBWF CFGSWI_OLD,W	; Porovnani stareho a noveho stavu switchu
		BTFSC STATUS,Z		; Pokud se zmnily spinace, zobrazi se mf
		GOTO KONECHC
		CALL ZOBRAZMF
		CALL ZHASNI1S
KONECHC	GOTO STARTCITANI	; Skok na zacatek mereni
		

; *** Podprogramy ***
 ;Mereni frekvence

ZOBRAZ1OKO
;		Zobrazi 16bitove binarni cislo postupne za sebou
;		na jednookem displeji, vypne preamp
;		Vstup:  16b cislo H_byte a L_byte
;				KLID_PORTB - klidovy stav portu, v bitu 5 nese info, zda se ma vzpnout predzseilovac
;		Vystup - porty A a B
		CALL B2_BCD			; Konverze bin do display bufferu
		CALL DISP_BCD_TO_BUF
ZOBR0	MOVLW D'6'
		MOVWF DISP_STAV		;	DISP_STAV=6;
		MOVLW DISP_BUFF+5
		MOVWF FSR			; FSR se nastavil na konec DISP_BUFF
ZOBR1	MOVF INDF, W
		SUBLW 0x00			; Test, zda nejsou zhasnute vyssi cislice - nuly
		BTFSC STATUS,Z		; pokud W==0, jdi na dalsi cislici
		GOTO ZOBRDALSI
		MOVLW D'5'			; bude se pozdeji rotovat 5x
		MOVWF JJ
		MOVF INDF, W		; do W se da kod cislice 
;		XORLW 0xFF			; Pokud bude mit displej spolecnou anodu, je treba aktivovat tento radek,
							; tj. negovat signaly pro displej
		MOVWF PORTA			; a posle se na port A, ale jen dolni 4 bity jdou do displeje
		MOVWF KK			; Do dolni pulky B dame horni 4 bity kodu cislice
		SWAPF KK, W			; do W prehozene 4 b z KK
		ANDLW B'00001111'	; nulovani vyssich bitu 4-7
		IORWF KLID_PORTB, W	; SK
		MOVWF PORTB			; PORTB= druha pulka kodu cislice
		MOVLW D'40'			; Cekej	0,4s	
		MOVWF LL
		CALL CEK10X		
		CALL ZHASDISP
		MOVLW D'6'			; Cekej 60 ms
		MOVWF LL
		CALL CEK10X
ZOBRDALSI  DECF FSR, F
		DECFSZ DISP_STAV,F	; --DISP_STAV; IF DISP_STAV >0 GOTO ZOBR1
		GOTO ZOBR1
		RETURN

ZHASNI1S	; * Zhasnuti displeje na 1 sekundu *
		CALL ZHASDISP
		MOVLW D'100'			; Cekej		
		MOVWF LL
		CALL CEK10X
		RETURN

TESTBAT	; Test baterie - rozsviti se displej vcetne des. tecky, zapne preamp
		; a cte se stav PORTA4, kde stav bat (vazano na rozsvicenou des. tecku)
		; Kdyz svit des. tecka a PORTA4=0 napajeci napeti je dobre,
		; pokud PORTA4=1, napeti je prilis male
		; pri malem napeti signaliyuje LbLbLb
		; na konec vzdy zhasne displej na 1s
		; Vstup: bit 4 portu B
		; Vystup: porty A a B
		MOVLW B'00101111'	; Rozsviceni displeje a zapnuti predzesilovace
		MOVWF PORTB
		MOVLW B'00001111'
		MOVWF PORTA
		MOVLW D'5'			; LL=5 pruchodu cekaci smyckou
		MOVWF LL
TBATCK	DECFSZ LL,F			; Cekaci smycka na ustaleni stavu
		GOTO TBATCK
		MOVLW B'00111000'	; Predem se da kod znaku L do W, protoze ted musime
		CLRWDT				; cekat, az se ustali stav na vstupu PORTA4
		BTFSS PORTA,4		; Cteni stavu baterie
		GOTO DOBRA_BAT		; Napeti je dostatecne - skok na zhasnuti displeje
		; Napajeci napeti je prilis male - zobrazi se Lb jako Low Battery 3x po sobe
		MOVWF DISP_BUFF+1	; Znak L do disp. buf
		MOVWF DISP_BUFF+3
		MOVWF DISP_BUFF+5
		CALL ZHASDISP	; Zhasnuti displeje, klid. stav do portu B
		MOVLW D'60'
		MOVWF LL
		CALL CEK10X
		MOVLW B'01111100'	; Znak b do disp. bufferu
		MOVWF DISP_BUFF		
		MOVWF DISP_BUFF+2
		MOVWF DISP_BUFF+4	
		CALL ZOBR0			; Zobrazeni obsahu displ. bufferu
DOBRA_BAT	CALL ZHASNI1S	; Zhasnuti displeje na 1 s
		RETURN

ZHASDISP	; * ZHASNI DISPLEJ
		; Vstup : KLID_PORTB
		CLRF PORTA			;
		MOVF KLID_PORTB, W
		MOVWF PORTB			; nastaveni klid. stavu portu B
		RETURN

DISP_BCD_TO_BUF
;	* Podprogram na prevod dat z BCD kodu do display bufferu *
;		Cte data z 3 bajtoveho pole DISP_BCD_INPUT,
;		uklada do 6 bajtoveho DISP_BUF
;		Pouziva pomocne promenne KK, LL, MM, EE, P_BUF, P_BCD
;		a registry W, STATUS a FSR
;		Je to zjednodusena verze pro jednomistny displej, nehodi se pro
;		multiplexni displej
 		MOVLW 3				; KK=3 CITAC CYKLU BCD bajtu
		MOVWF KK
		CLRF EE				; EE=0 pocitadlo do display bufferu
		MOVLW DISP_BUFF
		MOVWF P_BUF			;	Ukazatel display bufferu nastaven na zacatek
		MOVLW DISP_BCD_INPUT
		MOVWF P_BCD			;	Ukazatel BCD nastaven na zacatek (nejnizsi cislici)
BCDBF_CYKL	MOVWF FSR		; FSR ukazuje do pole BCD kodu
		MOVF INDF,0			; LL=W=*P_BCD
		MOVWF LL	 		
BCD1_CYKL	MOVF P_BUF,0
		MOVWF FSR			; FSR ukazuje do display bufferu 
		MOVF LL,0
		CLRF PCLATH			; PCLATH=0, protoze podprogram pouziva ADDWF PCL ve strance 0
		CALL DISPTAB		; smazani hornich 4 bitu z W a cteni z prevodni tabulky BCD/7segment
		MOVWF INDF			; V *P_BUF jsou doln 4 bity z LL, jedno cislo v BCD kodu		
	; Nastaveni desetinne tecky, ktera se vklada do bitu 7
		MOVF DECIMAL_DOT,0	; Jestlie se EE=DECIMAL_DOT 
		SUBWF EE,0
		BTFSC STATUS,Z		; nastavi se bit 4 v display bufferu
		BSF INDF,7		
	; Jedna cislice pro displej hotova.
		INCF P_BUF,1		; Inkrementace citacu display bufferu
		INCF EE,1
		SWAPF LL,F			; Prehozeni vyssi pulky vstupniho bajtu dolu ke zpracovani
		BTFSC EE,0			; Je-li EE lich, jdi na BCD1 cykl a zpracuj horn pulku bajtu
		GOTO BCD1_CYKL
		INCF P_BCD,1		; Inkrementace ukazatele BCD
		MOVF P_BCD,0		; a jeho naten do W, odkud se na zatku cyklu zkopruje do FSR
		DECFSZ KK, 1
		GOTO BCDBF_CYKL
		CLRWDT
	; Mazani zbytecnych nul
		MOVLW DISP_BUFF+5
		MOVWF FSR			; Nastaveni FSR na konec display bufferu (nejvyssi cislici).
		MOVLW D'5'
		MOVWF KK 			; Do KK se da pocet pruchodu cyklem
ODNULCY	MOVLW B'01111111'
		ANDWF INDF,W 		; Vybrani dolnich 7bitu z display bufferu do W
		SUBLW B'00111111'	; odecita se kod nuly
		BTFSS STATUS,Z 		; Neni kod cislice roven kodu nuly, jdi na konec
		GOTO KONEC_BCD_BUF
		BTFSC INDF,7		; Je-li nastavena desetinna tecka, jdi na konec
		GOTO KONEC_BCD_BUF
		CLRF INDF 			; Zhasni cislici zapisem 0
		DECF FSR,F			; Posunuti ukazatele o jednu cislici dolu (doprava)
		DECFSZ KK,F			; --KK; Je-li KK > 0 opakuj
		GOTO ODNULCY 
KONEC_BCD_BUF	RETURN		; Konec prevodu z BCD do display bufferu


CTISWITCH1	; Cteni cfg spinacu a nastaveni MF kmitoctu, zkracena verze
			; Vedlejsi efekt - zhasne displej a v zavislosti na KLID_PORTB muze vypnout predzesilovac
			; Vstup: bit 4 portu B
			; Vystup: CFGSWI, MF_L, MF_H
			; Meni promenne LL, KK, reg. PCLATH a porty A a B
		CALL ZHASDISP
;		BCF PORTB,0			; SA
		BSF PORTB,0			; SK Cteni spinace u bitu 0 na portu B
		CLRF CFGSWI
;		BTFSS PORTB,4		; SA
		BTFSC PORTB,4		; SK
		BSF CFGSWI,0
		MOVF KLID_PORTB, W
		MOVWF PORTB			; Klidovy stav do PORTB - zhasnout
		MOVLW D'4'			; Ted se budou cist spinace u dolnich 4 bitu portu A
		MOVWF LL			; LL=4
;		MOVLW B'11110111'	; SA nastavit 4. bit v KK na 0
		MOVLW B'00001000'	; SK nastavit 4. bit v KK na 1
		MOVWF KK
CTSWAC	MOVF KK,W			; KK do PORTA
		MOVWF PORTA
;		BSF STATUS,C		; SA KK rotovat doprava, zleva doplnit jednickou
		BCF STATUS,C		; SK KK rotovat doprava, zleva doplnit nulou
		RRF KK,F
		BCF STATUS,C		; CFGSWI rotovat doleva, zprava doplnit nulou
		RLF CFGSWI,F
;		BTFSS PORTB,4		; SA Pokud je sepnuto, nastav bit 0 v CFGSWI
		BTFSC PORTB,4		; SK Pokud je sepnuto, nastav bit 0 v CFGSWI
		BSF CFGSWI,0
		DECFSZ LL,F			; --LL, pokud je LL >0 jdi na CTSWAC
		GOTO CTSWAC
		CLRF PORTA			; Zhasnuti
		BTFSC CFGSWI,0		; Test, zda se ma odecitat MF
		GOTO CTIMF1			; Pokud se neodecita MF, do mf se daji 0
		CLRF MF_L
		CLRF MF_H
		GOTO KONEC_CTISWITCH
; Preceteni mf kmitoctu z tabulky
CTIMF1	MOVF CFGSWI,W	 
		MOVWF LL
		RRF LL,F
		RRF LL,F		
		MOVF LL,W
		CLRF PCLATH			; PCLATH=0, protoze podporgram pouziva ADDWF PCL ve strance 0
		CALL MFTAB_L
		MOVWF MF_L
		MOVF LL,W
		CLRF PCLATH			; PCLATH=0, protoze podporgram pouziva ADDWF PCL ve strance 0 
		CALL MFTAB_H
		MOVWF MF_H
		CALL ZHASDISP
KONEC_CTISWITCH	RETURN


ZOBRAZMF		;  Zobrazeni mf kmitoctu
		; Vstup: MF_L, MF_H
		MOVF MF_L,0	
		MOVWF L_byte
		MOVF MF_H,0
		MOVWF H_byte 
		MOVLW D'3'
		MOVWF DECIMAL_DOT
		CALL B2_BCD			; Konverze bin do display bufferu
		CALL DISP_BCD_TO_BUF
		MOVLW B'01011000'		; Do nejvyssiho mista displeje se da 'c'
		MOVWF DISP_BUFF+5
		CALL ZOBR0
		CLRF DISP_BUFF+5
		RETURN

CEK10X 	;Cekani LL krat 10 ms,
		; Vstup: LL
CK10X1	CALL CEK10
		DECFSZ LL,1
		GOTO CK10X1
		RETURN

CEK10	; Cekani 10 ms
		MOVLW D'10' ; KK=10
		MOVWF KK
CK10	CALL CEK1	; CEKANI 1 ms
		CLRWDT
		DECFSZ KK,1 
		GOTO CK10
		RETURN
		
CEK1	; Vnitrni cekaci smycka necela 1 ms
		CLRWDT			; zpozdeni 1 krok - jemna korekce delky
		MOVLW HRUBE1MS	; Vnitrni smycka se bude prochazet tolikrat, 
						; aby rutina CEK1 trvala 1 ms bez 10 kroku, 
		MOVWF EE
CKZB3	MOVF EE,1		; Vnitrni smycka, jeden pruchod ma trvat 8 us, 
		DECFSZ EE,1		; Pro 2 MHz krystal je vycpana 1 zbytecnou instrukci, aby trvala 4 kroky
		GOTO CKZB3	
		CLRWDT			; zpozdeni 1 krok
		RETURN


;********************************************************************
;                  Binary To BCD Conversion Routine
;      This routine converts a 16 Bit binary Number to a 5 Digit
; BCD Number. This routine is useful since PIC16C55 & PIC16C57
; have  two 8 bit ports and one 4 bit port ( total of 5 BCD digits)
;
;       The 16 bit binary number is input in locations H_byte and
; L_byte with the high byte in H_byte.
;       The 5 digit BCD number is returned in R0, R1 and R2 with R0
; containing the MSD in its right most nibble.
;
;   Performance :
;               Program Memory  :       35
;               Clock Cycles    :       885
;
;
;       Program:          B16TOBCD.ASM 
;       Revision Date:   
;                         1-13-97      Compatibility with MPASMWIN 1.40
;
;*******************************************************************;
;
count  equ      KK
temp   equ      LL
;

R0      equ     DISP_BCD_INPUT+2        ; RAM Assignments
R1      equ     DISP_BCD_INPUT+1
R2      equ     DISP_BCD_INPUT
;
B2_BCD  bcf     STATUS,0                ; clear the carry bit
		movlw   .16
		movwf   count
		clrf    R0
		clrf    R1
		clrf    R2
loop16  rlf     L_byte, F
		rlf     H_byte, F
		rlf     R2, F
		rlf     R1, F
		rlf     R0, F
;
		decfsz  count, F
		goto    adjDEC
		RETLW   0
;
adjDEC  movlw   R2
		movwf   FSR
		call    adjBCD
	;
		movlw   R1
		movwf   FSR

		call    adjBCD
       ;
		movlw   R0
		movwf   FSR
		call    adjBCD
       ;
		goto    loop16
	;
adjBCD  movlw   3
		addwf   0,W
		movwf   temp
		btfsc   temp,3          ; test if result > 7
		movwf   0
		movlw   30
		addwf   0,W
		movwf   temp
		btfsc   temp,7          ; test if result > 7
		movwf   0               ; save as MSD
		RETLW   0

;*******************************************************************
;         Double Precision Subtraction ( ACCb - ACCa -> ACCb )
;
D_SUB   call    NEG_A           ; At first negate ACCa; Then add
;
;*******************************************************************
;       Double Precision  Addition ( ACCb + ACCa -> ACCb )
; 		Dodelal jsem spravne vyhodnoceni preteceni, kdyz v ACCbHI je 0xFF
;		PJ
ACCbLO equ L_byte
ACCbHI equ H_byte
;
D_ADD   movf    ACCaLO,W
	BCF PRIZNAKY,7
	addwf   ACCbLO, F       ;add lsb
	btfsS   STATUS,C        ;add in carry
	GOTO	NOCARRY1
	incf    ACCbHI, F		; Prenos do vyssiho radu
	BTFSC	STATUS,Z	
	BSF		PRIZNAKY,7		; doslo k preteceni pri inkrementaci, nastavuje se priznak
NOCARRY1
	movf    ACCaHI,W
	addwf   ACCbHI, F       ;add msb
	BTFSC	PRIZNAKY,7		; Nastaveni carry, kdyz doslo k preteceni pri inkementaci
	BSF		STATUS,C
	retlw   0
;
;
NEG_A   comf    ACCaLO, F       ; negate ACCa ( -ACCa -> ACCa )
	incf    ACCaLO, F
	btfsc   STATUS,Z
	decf    ACCaHI, F
	comf    ACCaHI, F
	retlw   0




	end

